#region Copyright Syncfusion Inc. 2001 - 2006
//
//  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Diagnostics;
using System.Runtime.InteropServices;
using System.IO;
using System.Text;
using System.Xml;
using System.Xml.Serialization;

using Syncfusion.Windows.Forms;
using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Edit;
using Syncfusion.Windows.Forms.Edit.Dialogs;
using Syncfusion.Windows.Forms.Edit.Implementation.Config;
using Syncfusion.Windows.Forms.Edit.Interfaces;
using Syncfusion.Windows.Forms.Edit.Implementation.IO;
using Syncfusion.Windows.Forms.Edit.Implementation.Formatting;
using Syncfusion.Windows.Forms.Edit.Implementation.Parser;
using Syncfusion.IO;

namespace _CustomBookmarksDemo
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem4;
		
		private Bitmap image1, image2, image3, image4, selectedImage;
		private string BasePath = Path.GetDirectoryName(Application.ExecutablePath) + @"\..\..\Test Files\Test.lsp";
		private string ConfigPath = Path.GetDirectoryName(Application.ExecutablePath) + @"\..\..\config.xml";
		private string imagePath = Path.GetDirectoryName(Application.ExecutablePath) + @"\..\..\Images\";

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem menuItem10;
		private System.Windows.Forms.MenuItem menuItem11;
		private System.Windows.Forms.MenuItem menuItem12;
		private System.Windows.Forms.MenuItem menuItem13;
		private System.Windows.Forms.MenuItem menuItem14;
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.MenuItem menuItem9;
		private System.Windows.Forms.MenuItem menuItem15;
		private System.Windows.Forms.MenuItem menuItem16;
		private System.Windows.Forms.MenuItem menuItem17;
		private System.Windows.Forms.MenuItem menuItem18;
		private System.Windows.Forms.MenuItem menuItem19;
		private System.Windows.Forms.MenuItem menuItem20;
		private System.Windows.Forms.MenuItem menuItem21;
		private System.Windows.Forms.MenuItem menuItem22;
		private System.Windows.Forms.MenuItem menuItem23;
		private System.Windows.Forms.MenuItem menuItem24;
		private Syncfusion.Windows.Forms.Edit.EditControl editControl1;


		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			
			this.editControl1.Configurator.Open(ConfigPath);
			this.editControl1.ApplyConfiguration("LISP");

			this.editControl1.ShowOutliningCollapsers = true;		
			this.editControl1.ShowLineNumbers = true;
			this.editControl1.ShowIndicatorMargin = true;
			this.editControl1.LoadFile(BasePath);

			image1 = new Bitmap(imagePath + "Image1.ico");
			image2 = new Bitmap(imagePath + "Image2.ico");
			image3 = new Bitmap(imagePath + "Image3.ico");
			image4 = new Bitmap(imagePath + "Image4.ico");

			selectedImage = image4;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem18 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.menuItem17 = new System.Windows.Forms.MenuItem();
			this.menuItem10 = new System.Windows.Forms.MenuItem();
			this.menuItem11 = new System.Windows.Forms.MenuItem();
			this.menuItem12 = new System.Windows.Forms.MenuItem();
			this.menuItem13 = new System.Windows.Forms.MenuItem();
			this.menuItem14 = new System.Windows.Forms.MenuItem();
			this.menuItem8 = new System.Windows.Forms.MenuItem();
			this.menuItem9 = new System.Windows.Forms.MenuItem();
			this.menuItem21 = new System.Windows.Forms.MenuItem();
			this.menuItem16 = new System.Windows.Forms.MenuItem();
			this.menuItem15 = new System.Windows.Forms.MenuItem();
			this.menuItem19 = new System.Windows.Forms.MenuItem();
			this.menuItem20 = new System.Windows.Forms.MenuItem();
			this.menuItem22 = new System.Windows.Forms.MenuItem();
			this.menuItem24 = new System.Windows.Forms.MenuItem();
			this.menuItem23 = new System.Windows.Forms.MenuItem();
			this.editControl1 = new Syncfusion.Windows.Forms.Edit.EditControl();
			((System.ComponentModel.ISupportInitialize)(this.editControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1,
																					  this.menuItem10,
																					  this.menuItem8});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2,
																					  this.menuItem3,
																					  this.menuItem18,
																					  this.menuItem5,
																					  this.menuItem4,
																					  this.menuItem6,
																					  this.menuItem17,
																					  this.menuItem7});
			this.menuItem1.Shortcut = System.Windows.Forms.Shortcut.CtrlN;
			this.menuItem1.Text = "&File";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 0;
			this.menuItem2.Shortcut = System.Windows.Forms.Shortcut.CtrlN;
			this.menuItem2.ShowShortcut = false;
			this.menuItem2.Text = "&New";
			this.menuItem2.Click += new System.EventHandler(this.MainMenuClick);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 1;
			this.menuItem3.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
			this.menuItem3.ShowShortcut = false;
			this.menuItem3.Text = "&Open";
			this.menuItem3.Click += new System.EventHandler(this.MainMenuClick);
			// 
			// menuItem18
			// 
			this.menuItem18.Index = 2;
			this.menuItem18.Text = "-";
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 3;
			this.menuItem5.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
			this.menuItem5.ShowShortcut = false;
			this.menuItem5.Text = "&Save";
			this.menuItem5.Click += new System.EventHandler(this.MainMenuClick);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 4;
			this.menuItem4.Shortcut = System.Windows.Forms.Shortcut.CtrlShiftS;
			this.menuItem4.ShowShortcut = false;
			this.menuItem4.Text = "Save&As";
			this.menuItem4.Click += new System.EventHandler(this.MainMenuClick);
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 5;
			this.menuItem6.Text = "-";
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 7;
			this.menuItem7.Text = "E&xit";
			this.menuItem7.Click += new System.EventHandler(this.MainMenuClick);
			// 
			// menuItem17
			// 
			this.menuItem17.Index = 6;
			this.menuItem17.Text = "Close";
			this.menuItem17.Click += new System.EventHandler(this.MainMenuClick);
			// 
			// menuItem10
			// 
			this.menuItem10.Index = 1;
			this.menuItem10.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.menuItem11,
																					   this.menuItem12,
																					   this.menuItem13,
																					   this.menuItem14});
			this.menuItem10.Text = "ImageMenu";
			// 
			// menuItem11
			// 
			this.menuItem11.Index = 0;
			this.menuItem11.Text = "Image1";
			this.menuItem11.Click += new System.EventHandler(this.ImageMenuClick);
			// 
			// menuItem12
			// 
			this.menuItem12.Index = 1;
			this.menuItem12.Text = "Image2";
			this.menuItem12.Click += new System.EventHandler(this.ImageMenuClick);
			// 
			// menuItem13
			// 
			this.menuItem13.Index = 2;
			this.menuItem13.Text = "Image3";
			this.menuItem13.Click += new System.EventHandler(this.ImageMenuClick);
			// 
			// menuItem14
			// 
			this.menuItem14.Index = 3;
			this.menuItem14.Text = "Image4";
			this.menuItem14.Click += new System.EventHandler(this.ImageMenuClick);
			// 
			// menuItem8
			// 
			this.menuItem8.Index = 2;
			this.menuItem8.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem9,
																					  this.menuItem21,
																					  this.menuItem16,
																					  this.menuItem15,
																					  this.menuItem19,
																					  this.menuItem20,
																					  this.menuItem22,
																					  this.menuItem24,
																					  this.menuItem23});
			this.menuItem8.Text = "BookmarkMenu";
			// 
			// menuItem9
			// 
			this.menuItem9.Index = 0;
			this.menuItem9.Text = "Set Custom Indicator";
			this.menuItem9.Click += new System.EventHandler(this.BookmarkMenuClick);
			// 
			// menuItem21
			// 
			this.menuItem21.Index = 1;
			this.menuItem21.Text = "-";
			// 
			// menuItem16
			// 
			this.menuItem16.Index = 2;
			this.menuItem16.Text = "Set Bookmark";
			this.menuItem16.Click += new System.EventHandler(this.BookmarkMenuClick);
			// 
			// menuItem15
			// 
			this.menuItem15.Index = 3;
			this.menuItem15.Text = "Toggle Bookmark";
			this.menuItem15.Click += new System.EventHandler(this.BookmarkMenuClick);
			// 
			// menuItem19
			// 
			this.menuItem19.Index = 4;
			this.menuItem19.Text = "-";
			// 
			// menuItem20
			// 
			this.menuItem20.Index = 5;
			this.menuItem20.Text = "Clear Bookmarks";
			this.menuItem20.Click += new System.EventHandler(this.BookmarkMenuClick);
			// 
			// menuItem22
			// 
			this.menuItem22.Index = 6;
			this.menuItem22.Text = "-";
			// 
			// menuItem24
			// 
			this.menuItem24.Index = 7;
			this.menuItem24.Text = "Previous Bookmark";
			this.menuItem24.Click += new System.EventHandler(this.BookmarkMenuClick);
			// 
			// menuItem23
			// 
			this.menuItem23.Index = 8;
			this.menuItem23.Text = "Next Bookmark";
			this.menuItem23.Click += new System.EventHandler(this.BookmarkMenuClick);
			// 
			// editControl1
			// 
			this.editControl1.AutoIndentMode = Syncfusion.Windows.Forms.Edit.Enums.AutoIndentMode.Smart;
			this.editControl1.BackColor = System.Drawing.SystemColors.Window;
			this.editControl1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.editControl1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.editControl1.DropAllFiles = false;
			this.editControl1.FileExtensions = new string[] {
																".cs",
																".vb",
																".sql",
																".xml",
																".java",
																".pas",
																".html",
																".htm",
																".vbs",
																".js"};
			this.editControl1.Name = "editControl1";
			this.editControl1.ShowHorizontalSplitters = false;
			this.editControl1.ShowIndicatorMargin = false;
			this.editControl1.ShowLineNumbers = false;
			this.editControl1.ShowVerticalSplitters = false;
			this.editControl1.Size = new System.Drawing.Size(542, 445);
			this.editControl1.StatusBarSettings.StatusPanel.MinWidth = 70;
			this.editControl1.StatusBarSettings.TextPanel.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.editControl1.TabIndex = 0;
			this.editControl1.Text = "";
			this.editControl1.TransferFocusOnTab = true;
			this.editControl1.UseXPStyle = false;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(542, 445);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.editControl1});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Custom Bookmarks Demo";
			((System.ComponentModel.ISupportInitialize)(this.editControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void MainMenuClick(object sender, System.EventArgs e)
		{
			MenuItem mi = sender as MenuItem;

			switch (mi.Text)
			{
				case "&New" :
					this.editControl1.NewFile();
					break;
				case "&Open" :
					this.editControl1.LoadFile();
					break;
				case "&Save" :
					this.editControl1.Save();
					break;
				case "Save&As" :
					this.editControl1.SaveAs();
					break;
				case "Close" :
					this.editControl1.Close();
					break;
				case "E&xit" :
					this.Close();
					break;
			}
		}

		private void BookmarkMenuClick(object sender, System.EventArgs e)
		{
			this.editControl1.ShowIndicatorMargin = true;

			MenuItem mi = sender as MenuItem;

			switch (mi.Text)
			{
				case "Set Custom Indicator" :
					if (this.selectedImage == image1)
					{
						ICustomBookmark bookmark1 = this.editControl1.SetCustomBookmark(this.editControl1.CurrentLine, new BookmarkPaintEventHandler( CustomBookmarkPainter1 ));
						bookmark1.UseInBookmarkSearch = true;
					}

					else if (this.selectedImage == image2)
					{
						ICustomBookmark bookmark2 = this.editControl1.SetCustomBookmark(this.editControl1.CurrentLine, new BookmarkPaintEventHandler( CustomBookmarkPainter2 ));
						bookmark2.UseInBookmarkSearch = true;
					}

					else if (this.selectedImage == image3)
					{
						ICustomBookmark bookmark3 = this.editControl1.SetCustomBookmark(this.editControl1.CurrentLine, new BookmarkPaintEventHandler( CustomBookmarkPainter3 ));
						bookmark3.UseInBookmarkSearch = true;
					}

					else if (this.selectedImage == image4)
					{
						ICustomBookmark bookmark4 = this.editControl1.SetCustomBookmark(this.editControl1.CurrentLine, new BookmarkPaintEventHandler( CustomBookmarkPainter4 ));
						bookmark4.UseInBookmarkSearch = true;
					}
					this.editControl1.Refresh();
					break;

				case "Set Bookmark" :
					this.editControl1.BookmarkAdd(this.editControl1.CurrentLine);
					break;

				case "Toggle Bookmark" :
					this.editControl1.BookmarkToggle();
					this.editControl1.Refresh();
					break;

				case "Clear Bookmarks" :
					this.editControl1.BookmarkClear(true);
					this.editControl1.Refresh();
					break;

				case "Previous Bookmark" :
					this.editControl1.BookmarkPrevious();
					break;

				case "Next Bookmark" :
					this.editControl1.BookmarkNext();
					break;
			}
		}	

		private void CustomBookmarkPainter1 (object sender, BookmarkPaintEventArgs args)
		{
			args.Graphics.DrawImage(image1, args.ClipRectangle.Left, args.ClipRectangle.Top, 16, 16 ); 
		}

		private void CustomBookmarkPainter2 (object sender, BookmarkPaintEventArgs args)
		{
			args.Graphics.DrawImage(image2, args.ClipRectangle.Left, args.ClipRectangle.Top, 16, 16 ); 
		}

		private void CustomBookmarkPainter3 (object sender, BookmarkPaintEventArgs args)
		{
			args.Graphics.DrawImage(image3, args.ClipRectangle.Left, args.ClipRectangle.Top, 16, 16 ); 
		}

		private void CustomBookmarkPainter4 (object sender, BookmarkPaintEventArgs args)
		{
			args.Graphics.DrawImage(image4, args.ClipRectangle.Left, args.ClipRectangle.Top, 16, 16 ); 
		}

		private void ImageMenuClick(object sender, System.EventArgs e)
		{
			MenuItem mi = sender as MenuItem;

			switch (mi.Text)
			{
				case "Image1" :
					this.selectedImage = image1;
					break;
				case "Image2" :
					this.selectedImage = image2;
					break;
				case "Image3" :
					this.selectedImage = image3;
					break;
				case "Image4" :
					this.selectedImage = image4;
					break;		
			}
		}
	}
}
